function strCode(str) {  //获取字符串的字节数
    var count = 0;  //初始化字节数递加变量并获取字符串参数的字符个数
    var cn = [8211, 8212, 8216, 8217, 8220, 8221, 8230, 12289, 12290, 12296, 12297, 12298, 12299, 12300, 12301, 12302, 12303, 12304, 12305, 12308, 12309, 65281, 65288, 65289, 65292, 65294, 65306, 65307, 65311]
    var half = [32, 33, 34, 35, 36, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 58, 59, 60, 61, 62, 63, 64, 91, 92, 93, 94, 95, 96, 123, 124, 125, 126,105,108,8211]
    if (str) {  //如果存在字符串，则执行
        len = str.length; 
        for (var i = 0; i < len; i++) {  //遍历字符串，枚举每个字符
          let charCode = str.charCodeAt(i)
            if (charCode>=65 && charCode<=90) {
              count += 1.5;  //大写
            } else if (half.includes(charCode)) {
              count +=0.45
            } else if (cn.includes(charCode)) {
              count +=0.8
            }else if (charCode > 255) {  //字符编码大于255，说明是双字节字符(即是中文)
                count += 2;  //则累加2个
            }else{
                count++;  //否则递加一次
            }
        }
        return count;  //返回字节数
    } else {
        return 0;  //如果参数为空，则返回0个
    }
}

function getSplitLine() {
  let focusWindow = Application.sharedInstance().focusWindow

    let studyFrame = Application.sharedInstance().studyController(focusWindow).view.bounds
    let readerFrame = Application.sharedInstance().studyController(focusWindow).readerController.view.frame
    let hidden = Application.sharedInstance().studyController(focusWindow).readerController.view.hidden//true代表脑图全屏
    let rightMode = Application.sharedInstance().studyController(focusWindow).rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      return undefined
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }

function undoGroupingWithRefresh(notebookid,f){
  UndoManager.sharedInstance().undoGrouping(
    String(Date.now()),
    notebookid,
    f
  )
  Application.sharedInstance().refreshAfterDBChanged(notebookid)
}

function getWebJS(id) {
  switch (id) {
    case "updateDeeplOffset":
      return `document.getElementsByClassName("dl_header")[0].style.display="none";
        document.getElementsByClassName("lmt__docTrans-tab-container")[0].style.display="none";
        document.getElementsByClassName("lmt__sides_container")[0].style.margin = 0;
        document.querySelector("#dl_translator").style.cssText = "padding-top: 20px";
        document.getElementsByClassName("lmt__language_container")[0].style.display = "none";
        document.getElementsByClassName("lmt__language_container")[1].style.display = "none";
        document.getElementsByClassName("lmt__target_toolbar")[0].style.display = "none";
        document.querySelector("#dl_cookieBanner").style.display="none";
        document.querySelector("#lmt_quotes_article").style.display="none";
        document.querySelector("#lmt__dict").style.margin = 0;
        document.querySelector("#lmt_pro_ad_container").style.display = "none";
        document.querySelector("body > div.dl_footerV2_container").style.display = "none";`
    case "updateThesaurusOffset":
      return `document.getElementsByTagName("header")[0].style.display = "none"
        document.getElementsByTagName("section")[0].style.display = "none"
        document.getElementsByTagName("section")[6].style.display = "none"
        document.getElementsByTagName("section")[7].style.display = "none"
        document.getElementsByTagName("section")[8].style.display = "none"
        document.getElementsByTagName("section")[9].style.display = "none"
        document.getElementsByTagName("p")[5].style.display = "none"
        document.getElementsByClassName("acw ac-widget-placeholder ac-reset")[0].style.display = "none"`
    case "updateBilibiliOffset":
      return `
      document.getElementsByClassName("v-popover-wrap")[0].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[1].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[2].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[3].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[4].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[5].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[6].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[8].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[10].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[11].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[13].style.display = "none";
      document.getElementsByClassName("recommended-swipe grid-anchor")[0].style.display = "none";
      `
    default:
      return ""
  }
}

function hexColorAlpha(hex,alpha) {
  let color = UIColor.colorWithHexString(hex)
  return alpha!==undefined?color.colorWithAlphaComponent(alpha):color
}

function genFrame(x,y,width,height) {
  return {x:x,y:y,width:width,height:height}
}

function getOrderText(order) {
  let orderNumber = `${order[0]}${order[1]}${order[2]}`
  switch (orderNumber) {
    case "123":
      return 'Order: Title → Excerpt → Comment'
    case "132":
      return 'Order: Title → Comment → Excerpt'
    case "213":
      return 'Order: Excerpt → Title → Comment'
    case "231":
      return 'Order: Excerpt → Comment → Title'
    case "312":
      return 'Order: Comment → Title → Excerpt'
    case "321":
      return 'Order: Comment → Excerpt → Title'
    default:
      return "123";
  }
}

function shouldPrevent(currentURL,requestURL,type) {
  let firstCheck = Application.sharedInstance().osType === 0 && (type===0 || /^https:\/\/m.inftab.com/.test(currentURL))
  if (firstCheck) {
    let blacklist = ["^https?://www.bilibili.com","^https?://m.bilibili.com","^https?://space.bilibili.com","^https?://t.bilibili.com","^https?://www.wolai.com","^https?://flowus.com","^https?://www.notion.so"]
    if (blacklist.some(url=>RegExp(url).test(requestURL))) {
      return true
    }
  }
  return false
}

function showHUD(message,duration=2) {
  let focusWindow = Application.sharedInstance().focusWindow
  Application.sharedInstance().showHUD(message,focusWindow,2)
}

function refreshAfterDBChanged(notebookid) {
  Application.sharedInstance().refreshAfterDBChanged(notebookid)
  
}

function getSelectNodes() {
  let focusWindow = Application.sharedInstance().focusWindow
  let nodes =self.appInstance.studyController(focusWindow).notebookController.mindmapView.selViewLst.map(item=>item.note.note)
  return nodes
}