JSB.require('utils')
var toolbarController = JSB.defineClass('toolbarController : UIViewController', {
  viewDidLoad: function() {
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNAutoStyle")
    // let config  =  NSUserDefaults.standardUserDefaults().objectForKey("MNAutoStyle")
    self.appInstance = Application.sharedInstance();
    self.homeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/home.png`), 2)
    self.bothModeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/bothMode.png`), 2)
    self.goforwardImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goforward.png`), 2)
    self.screenImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/screen.png`), 2)
    self.snipasteImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/snipaste.png`), 2)
    self.closeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/stop.png`), 2)
    self.custom = false;
    self.customMode = "None"
    self.miniMode = false;
    self.isLoading = false;
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.buttonNumber = 4
    self.mode = 0
    self.moveDate = Date.now()
// 0都没有
// 1都有
// 2image
// 3text
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.opacity = 1.0
    self.view.layer.cornerRadius = 5
    self.view.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0.8)
    self.highlightColor = UIColor.blendedColor(
      UIColor.colorWithHexString("#2c4d81").colorWithAlphaComponent(0.8),
      Application.sharedInstance().defaultTextColor,
      0.8
    );

// >>> opacity button >>>
    // self.webAppButton.titleLabel.font = UIFont.systemFontOfSize(12);
    // <<< opacity button <<<

    // >>> max button >>>
    self.maxButton = UIButton.buttonWithType(0);
    // self.setButtonLayout(self.maxButton,"maxButtonTapped:")
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< max button <<<


    // <<< search button <<<
    // >>> move button >>>
    self.moveButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.moveButton)
    // <<< move button <<<

    // self.imageModeButton.setTitleForState('🔍', 0);
    // self.tabButton      = UIButton.buttonWithType(0);
    self.color = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9fdc"]
    self.imageName = ["copyExcerptPic","searchInEudic","switchTitleorExcerpt","copyAsMarkdownLink","snipaste","home"]
    self.action = ["copy","searchInEudic","switchTitleorExcerpt","copyAsMarkdownLink","snipaste","search"]
    self.doubleClickAction = ["copyTitle","searchInEudic","switchTitle","link","snipaste","search"]

    for (let index = 0; index < self.buttonNumber; index++) {
      self["ColorButton"+index]   = UIButton.buttonWithType(0);
      self["ColorButton"+index].index = index
      self.setColorButtonLayout(self["ColorButton"+index],self.action[index]+":","#ffffff")
      self["ColorButton"+index].setImageForState(UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/${self.imageName[index]}.png`), 2),0)
      // self["ColorButton"+index].setTitleForState(self.imagePattern[index]===self.textPattern[index]?` ${self.imagePattern[index]} `:"-1",0) 
    }
        // >>> screen button >>>
    self.screenButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.screenButton,"changeScreen:")

    // self.setButtonLayout(self.screenButton,"changeScreen:")
    // self.screenButton.setImageForState(self.screenImage,0)
    // <<< screen button <<<
    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")
    // self.moveButton.addGestureRecognizer(self.moveGesture)
    // self.imageModeButton.addGestureRecognizer(self.moveGesture)
    // self.bothModeButton.addGestureRecognizer(self.moveGesture)




    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
viewWillLayoutSubviews: function() {
    var viewFrame = self.view.bounds;
    var xLeft     = viewFrame.x
    var xRight    = xLeft + viewFrame.width
    var yTop      = viewFrame.y
    var yBottom   = yTop + viewFrame.height
    self.moveButton.frame = {x: 0 ,y: 0,width: 40,height: 15};
    self.screenButton.frame = {x: 0 ,y: yBottom-15,width: 40,height: 15};

    let initX = 0
    let initY = 20
    for (let index = 0; index < self.buttonNumber; index++) {
      initX = 0
      self["ColorButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: 40,  height: 40,};
      initY = initY+40
      self["ColorButton"+index].hidden = (initY > yBottom)
    }

  },
  scrollViewDidScroll: function() {
  },
  changeColorPattern: function (sender) {
    //  Application.sharedInstance().showHUD("index:"+sender.index, self.view.window, 2);

    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    let imagePattern    = self.imagePattern[sender.index]
    let textPattern     = self.textPattern[sender.index]
    let searchPattern  = self.searchPattern[sender.index]
    let bigbangPattern  = self.bigbangPattern[sender.index]
    let snipastePattern = self.snipastePattern[sender.index]
    let copyPattern = self.copyPattern[sender.index]

    let checkList
    switch (self.mode) {
      case 0:
        checkList = ((imagePattern===textPattern)?[imagePattern===0,imagePattern===1,imagePattern===2]:[false,false,false]).concat(copyPattern===1,searchPattern===1,bigbangPattern===1,snipastePattern===1)
        break;
      case 1:
        checkList = [textPattern===0,textPattern===1,textPattern===2,copyPattern===1||copyPattern===2,searchPattern===1||searchPattern===2,bigbangPattern===1||bigbangPattern===2,snipastePattern===1||snipastePattern===2]
        break
      case 2:
        checkList = [imagePattern===0,imagePattern===1,imagePattern===2,copyPattern===1||copyPattern===3,searchPattern===1||searchPattern===3,bigbangPattern===1||bigbangPattern===3,snipastePattern===1||snipastePattern===3]
        break
      default:
        break;
    }
    menuController.commandTable = [
      {title:'0️⃣ Both',object:self,selector:'setBothPattern:',param:sender,checked:checkList[0]},
      {title:'1️⃣ Fill',object:self,selector:'setFillPattern:',param:sender,checked:checkList[1]},
      {title:'2️⃣ Border',object:self,selector:'setBorderPattern:',param:sender,checked:checkList[2]},
      {title:'Auto copy',object:self,selector:'setAutoCopy:',param:sender,checked:checkList[3]},
      {title:'Auto search',object:self,selector:'setAutoSearch:',param:sender,checked:checkList[4]},
      {title:'Auto bigbang',object:self,selector:'setAutoBigbang:',param:sender,checked:checkList[5]},
      {title:'Auto snipaste',object:self,selector:'setAutoSnipaste:',param:sender,checked:checkList[6]},

    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 200,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 100,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
    // self.webAppButton.setTitleForState(`${opacity*100}%`, 0);
  },
  changeScreen: function(sender) {
    self.onClick = true
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    // let dynamic = NSUserDefaults.standardUserDefaults().objectForKey("MNToolbar_dynamic")
    
    menuController.commandTable = [
      {title:'🌟 Dynamic',object:self,selector:'toggleDynamic:',param:1.0,checked:self.dynamic}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 200,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  toggleDynamic: function () {
    self.onClick = true
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('toggleDynamic', self.view.window, {test:123})
  },
  copy:function (button) {
    self.onClick = true
    if (button.doubleClick) {
        let focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
        let text = focusNote.noteTitle
        if (text) {
          UIPasteboard.generalPasteboard().string = text
          showHUD('标题已复制')
        }else{
          showHUD('无标题')
        }
        button.doubleClick = false
      return
    }
    let focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
    if (focusNote.excerptText) {
      if (focusNote.excerptPic) {
        let imageData = Database.sharedInstance().getMediaByHash(focusNote.excerptPic.paint)
        UIPasteboard.generalPasteboard().setDataForPasteboardType(imageData,"public.png")
        showHUD('摘录图片已复制')
      }else{
        let text = focusNote.excerptText
        UIPasteboard.generalPasteboard().string = text
        showHUD('摘录文字已复制')
      }
    }else{
      let firstComment = focusNote.comments[0]
      switch (firstComment.type) {
        case "TextNote":
          UIPasteboard.generalPasteboard().string = firstComment.text
          showHUD('首条评论已复制')
          break;
        case "PaintNote":
          let imageData = Database.sharedInstance().getMediaByHash(firstComment.paint)
          UIPasteboard.generalPasteboard().setDataForPasteboardType(imageData,"public.png")
          showHUD('首条评论已复制')
          break;
        default:
          showHUD('暂不支持的评论类型')
          break;
      }
    }
  },
  copyAsMarkdownLink(button) {
    self.onClick = true
    // profile.click = profile.click+1
    var pasteBoard = UIPasteboard.generalPasteboard()
    // let nodes =self.appInstance.studyController(self.view.window).notebookController.mindmapView.selViewLst.map(item=>item.note.note)
try {
  

    const nodes = getSelectNodes()
    let text = ""
    if (button.doubleClick) {
      button.doubleClick = false
      for (const note of nodes) {
        var noteid = note.noteId
        text = text+'marginnote3app://note/'+noteid+'\n'
      }
      showHUD("链接已复制")

    }else{
      for (const note of nodes) {
      var noteid = note.noteId
      let noteTitle = note.noteTitle
      noteTitle = noteTitle?noteTitle:"noTitle"
      text = text+'['+noteTitle+'](marginnote3app://note/'+noteid+')'+'\n'
      }
      showHUD("Markdown链接已复制")
    }

    pasteBoard.string = text.trim()
    // const success = await delay(0.5)
    // profile.click = 0
} catch (error) {
  showHUD(error)
}
  },

  searchInEudic:function () {
    self.onClick = true
    let textSelected =self.appInstance.studyController(self.view.window).readerController.currentDocumentController.selectionText
    if (!textSelected) {
      let focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
      if (focusNote.excerptText && !focusNote.excerptPic) {
        textSelected = focusNote.excerptText
      }else if (focusNote.noteTitle) {
        textSelected = focusNote.noteTitle
      }else{
        let firstComment = focusNote.comments.filter(comment=>comment.type === "TextNote")[0]
        if (firstComment) {
          textSelected = firstComment.text
        }
      }
    }
    if (textSelected) {
      let url = "eudic://dict/"+textSelected
      Application.sharedInstance().openURL(NSURL.URLWithString(url));
    }else{
      showHUD('未找到有效文字')
    }
  },
  switchTitleorExcerpt() {
    self.onClick = true
    let nodes =self.appInstance.studyController(self.view.window).notebookController.mindmapView.selViewLst.map(item=>item.note.note)
    for (const note of nodes) {
      let title = note.noteTitle ?? ""
      let text = note.excerptText ?? ""
      // 只允许存在一个
      if ((title || text) && !(title && text)) {
        // 去除划重点留下的 ****
        note.noteTitle = text.replace(/\*\*(.*?)\*\*/g, "$1")
        note.excerptText = title
      } else if (title == text) {
        // 如果摘录与标题相同，MN 只显示标题，此时我们必然想切换到摘录
        note.noteTitle = ""
      }
    }
    refreshAfterDBChanged(self.notebookid)
    showHUD("标题转换完成")
  },
  doubleClick:function (button) {
    button.doubleClick = true
  },
  onMoveGesture:function (gesture) {

    let locationToMN = gesture.locationInView(self.appInstance.studyController(self.view.window).view)
    if ( (Date.now() - self.moveDate) > 100) {
      let translation = gesture.translationInView(self.appInstance.studyController(self.view.window).view)
      let locationToBrowser = gesture.locationInView(self.view)
      let locationToButton = gesture.locationInView(gesture.view)
      let buttonFrame = self.moveButton.frame
      let newY = locationToButton.y-translation.y 
      let newX = locationToButton.x-translation.x
      if (gesture.state !== 3 && (newY<buttonFrame.height+5 && newY>-5 && newX<buttonFrame.width+5 && newX>-5 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
        gesture.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
      }
    }
    self.moveDate = Date.now()
    let splitLine = getSplitLine()
    let docMapSplitMode = Application.sharedInstance().studyController(self.view.window).docMapSplitMode
    let location = {x:locationToMN.x - gesture.locationToBrowser.x,y:locationToMN.y -gesture.locationToBrowser.y}
    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
    let y = location.y
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = location.x
    if (x<20) {
      x = 0
    }
    if (x>studyFrame.width-60) {
      x = studyFrame.width-40
    }
    if (splitLine && docMapSplitMode===1) {
      if (x<splitLine && x>splitLine-40) {
        x = splitLine-20
        self.splitMode = true
      }else{
        self.splitMode = false
      }
    }else{
      self.splitMode = false
    }
    // if (splitLine !== 0) {
      
      // Application.sharedInstance().showHUD("splitLine:"+splitLine, self.view.window, 2);
    // }
    
    if (self.custom) {
      self.customMode = "None"
      self.view.frame = {x:x,y:y,width:self.lastFrame.width,height:self.lastFrame.height}
      self.currentFrame  = self.view.frame
    }else{
      self.view.frame = {x:x,y:y,width:frame.width,height:frame.height}
      self.currentFrame  = self.view.frame

    }
    NSUserDefaults.standardUserDefaults().setObjectForKey({open:true,frame:self.view.frame},"MNToolbar_windowState")

    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let frame = self.view.frame
    let width = locationInView.x+baseframe.x+baseframe.width*0.5
    let height = locationInView.y+baseframe.y+baseframe.height*0.5
    if (height<=40) {
      height = 40
    }
    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:frame.width,height:height}
    self.currentFrame  = self.view.frame
  },
});
toolbarController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 5;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}
toolbarController.prototype.setColorButtonLayout = function (button,targetAction,color) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.blackColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString(color).colorWithAlphaComponent(0.8);
    // button.layer.cornerRadius = 5;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
      button.addTargetActionForControlEvents(this, "doubleClick:", 1 << 1);
    }
    
    this.view.addSubview(button);
}
toolbarController.prototype.autoAction = function (focusNote) {
  let colorIndex = focusNote.colorIndex
  let shouldSearch
  let shouldBigbang
  let shouldSnipaste
  let shouldCopy
  if (focusNote.excerptPic) {
    shouldSearch = [1,3].includes(this.searchPattern[colorIndex])
    shouldBigbang = [1,3].includes(this.bigbangPattern[colorIndex])
    shouldSnipaste = [1,3].includes(this.snipastePattern[colorIndex])
    shouldCopy = [1,3].includes(this.copyPattern[colorIndex])
  }else{
    shouldSearch = [1,2].includes(this.searchPattern[colorIndex])
    shouldBigbang = [1,2].includes(this.bigbangPattern[colorIndex])
    shouldSnipaste = [1,2].includes(this.snipastePattern[colorIndex])
    shouldCopy = [1,2].includes(this.copyPattern[colorIndex])
  }
  if (shouldSearch) {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('searchInBrowser', this.appInstance.focusWindow, {text:focusNote.excerptText.trim()})
  }
  if (shouldBigbang) {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('bigbangNote', this.appInstance.focusWindow, {noteid:focusNote.noteId})
    // this.appInstance.showHUD("shouldBigbang",this.view.window)
  }
  if (shouldSnipaste) {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('snipasteNote', this.appInstance.focusWindow, {noteid:focusNote.noteId})
    // this.appInstance.showHUD("shouldSnipaste",this.view.window)
  }
  if (shouldCopy) {
    if (focusNote.excerptPic) {
      let imageData = Database.sharedInstance().getMediaByHash(focusNote.excerptPic.paint)
      UIPasteboard.generalPasteboard().setDataForPasteboardType(imageData,"public.png")
      // self.appInstance.showHUD('截图已复制到剪贴板',self.view.window,2)
    }else{
      UIPasteboard.generalPasteboard().string = focusNote.excerptText
    }
  }
}
toolbarController.prototype.show = function (frame) {
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  if (frame) {
    this.view.frame = frame
    this.currentFrame = frame
  }
  this.view.hidden = false
  this.moveButton.hidden = true
  this.screenButton.hidden = true
  for (let index = 0; index < this.buttonNumber; index++) {
    this["ColorButton"+index].hidden = true
  }
  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.layer.opacity = preOpacity
    this.view.frame = preFrame
    this.currentFrame = preFrame
  },
  ()=>{
    this.view.layer.borderWidth = 0
    this.moveButton.hidden = false
    this.screenButton.hidden = false

    for (let index = 0; index < this.buttonNumber; index++) {
      self["ColorButton"+index].hidden = (self["ColorButton"+index].frame.y+40 > yBottom)
    }
  })
}
toolbarController.prototype.hide = function (frame) {
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity
        // Application.sharedInstance().showHUD(JSON.stringify(frame),this.view.window,2)
  // this.moveButton.hidden = true
  for (let index = 0; index < this.buttonNumber; index++) {
    this["ColorButton"+index].hidden = true
  }
  UIView.animateWithDurationAnimationsCompletion(0.25,()=>{
    this.view.layer.opacity = 0.2
    if (frame) {
      this.view.frame = frame
      this.currentFrame = frame
    }
    // this.view.frame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
    // this.currentFrame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
  },
  ()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    this.currentFrame = preFrame

  })
}